package cn.palmte.work.bean;

import java.math.BigDecimal;

/**
 * 预算概算页面的公共属性
 * @author xiongshiyan at 2021/11/1 , contact me with email yanshixiong@126.com or phone 15208384257
 */
public class IncomeCostBean {
    /**
     * 设备类收入含税
     */
    private BigDecimal incomeDeviceTaxInclude;
    /**
     * 工程类收入含税
     */
    private BigDecimal incomeEngineerTaxInclude;
    /**
     * 服务类收入含税
     */
    private BigDecimal incomeServiceTaxInclude;

    /**
     * 设备类收入不含税
     */
    private BigDecimal incomeDeviceTaxExclude;
    /**
     * 工程类收入不含税
     */
    private BigDecimal incomeEngineerTaxExclude;
    /**
     * 服务类收入不含税
     */
    private BigDecimal incomeServiceTaxExclude;
    /**
     *设备采购成本含税
     */
    private BigDecimal costPurchaseDeviceTaxInclude;
    /**
     * 施工采购成本含税
     */
    private BigDecimal costPurchaseBuildTaxInclude;
    /**
     * 服务采购成本含税
     */
    private BigDecimal costPurchaseServiceTaxInclude;
    /*private BigDecimal costProjectManageTaxInclude;*/
    /**
     * 其他采购成本含税
     */
    private BigDecimal costPurchaseOtherTaxInclude;
    /**
     * 其他成本含税
     */
    private BigDecimal costOtherOtherTaxInclude;
    /**
     *设备采购成本不含税
     */
    private BigDecimal costPurchaseDeviceTaxExclude;
    /**
     * 施工采购成本不含税
     */
    private BigDecimal costPurchaseBuildTaxExclude;
    /**
     * 服务采购成本不含税
     */
    private BigDecimal costPurchaseServiceTaxExclude;
    /**
     * 其他采购成本不含税
     */
    private BigDecimal costPurchaseOtherTaxExclude;
    /**
     * 工程管理成本不含税
     */
    private BigDecimal costProjectManageTaxExclude;
    /**
     * 其他成本不含税
     */
    private BigDecimal costOtherOtherTaxExclude;

    /**
     * 资金占用成本不含税
     */
    private BigDecimal costExpropriationTaxExclude;
    /**
     *公司管理成本不含税
     */
    private BigDecimal costCompanyManageTaxExclude;

    public BigDecimal getIncomeDeviceTaxInclude() {
        return incomeDeviceTaxInclude;
    }

    public void setIncomeDeviceTaxInclude(BigDecimal incomeDeviceTaxInclude) {
        this.incomeDeviceTaxInclude = incomeDeviceTaxInclude;
    }

    public BigDecimal getIncomeEngineerTaxInclude() {
        return incomeEngineerTaxInclude;
    }

    public void setIncomeEngineerTaxInclude(BigDecimal incomeEngineerTaxInclude) {
        this.incomeEngineerTaxInclude = incomeEngineerTaxInclude;
    }

    public BigDecimal getIncomeServiceTaxInclude() {
        return incomeServiceTaxInclude;
    }

    public void setIncomeServiceTaxInclude(BigDecimal incomeServiceTaxInclude) {
        this.incomeServiceTaxInclude = incomeServiceTaxInclude;
    }

    public BigDecimal getIncomeDeviceTaxExclude() {
        return incomeDeviceTaxExclude;
    }

    public void setIncomeDeviceTaxExclude(BigDecimal incomeDeviceTaxExclude) {
        this.incomeDeviceTaxExclude = incomeDeviceTaxExclude;
    }

    public BigDecimal getIncomeEngineerTaxExclude() {
        return incomeEngineerTaxExclude;
    }

    public void setIncomeEngineerTaxExclude(BigDecimal incomeEngineerTaxExclude) {
        this.incomeEngineerTaxExclude = incomeEngineerTaxExclude;
    }

    public BigDecimal getIncomeServiceTaxExclude() {
        return incomeServiceTaxExclude;
    }

    public void setIncomeServiceTaxExclude(BigDecimal incomeServiceTaxExclude) {
        this.incomeServiceTaxExclude = incomeServiceTaxExclude;
    }

    public BigDecimal getCostPurchaseDeviceTaxInclude() {
        return costPurchaseDeviceTaxInclude;
    }

    public void setCostPurchaseDeviceTaxInclude(BigDecimal costPurchaseDeviceTaxInclude) {
        this.costPurchaseDeviceTaxInclude = costPurchaseDeviceTaxInclude;
    }

    public BigDecimal getCostPurchaseBuildTaxInclude() {
        return costPurchaseBuildTaxInclude;
    }

    public void setCostPurchaseBuildTaxInclude(BigDecimal costPurchaseBuildTaxInclude) {
        this.costPurchaseBuildTaxInclude = costPurchaseBuildTaxInclude;
    }

    public BigDecimal getCostPurchaseServiceTaxInclude() {
        return costPurchaseServiceTaxInclude;
    }

    public void setCostPurchaseServiceTaxInclude(BigDecimal costPurchaseServiceTaxInclude) {
        this.costPurchaseServiceTaxInclude = costPurchaseServiceTaxInclude;
    }


    /*public BigDecimal getCostProjectManageTaxInclude() {
        return costProjectManageTaxInclude;
    }

    public void setCostProjectManageTaxInclude(BigDecimal costProjectManageTaxInclude) {
        this.costProjectManageTaxInclude = costProjectManageTaxInclude;
    }*/

    public BigDecimal getCostPurchaseOtherTaxInclude() {
        return costPurchaseOtherTaxInclude;
    }
    public void setCostPurchaseOtherTaxInclude(BigDecimal costPurchaseOtherTaxInclude) {
        this.costPurchaseOtherTaxInclude = costPurchaseOtherTaxInclude;
    }

    public BigDecimal getCostOtherOtherTaxInclude() {
        return costOtherOtherTaxInclude;
    }

    public void setCostOtherOtherTaxInclude(BigDecimal costOtherOtherTaxInclude) {
        this.costOtherOtherTaxInclude = costOtherOtherTaxInclude;
    }

    public BigDecimal getCostPurchaseDeviceTaxExclude() {
        return costPurchaseDeviceTaxExclude;
    }

    public void setCostPurchaseDeviceTaxExclude(BigDecimal costPurchaseDeviceTaxExclude) {
        this.costPurchaseDeviceTaxExclude = costPurchaseDeviceTaxExclude;
    }

    public BigDecimal getCostPurchaseBuildTaxExclude() {
        return costPurchaseBuildTaxExclude;
    }

    public void setCostPurchaseBuildTaxExclude(BigDecimal costPurchaseBuildTaxExclude) {
        this.costPurchaseBuildTaxExclude = costPurchaseBuildTaxExclude;
    }

    public BigDecimal getCostPurchaseServiceTaxExclude() {
        return costPurchaseServiceTaxExclude;
    }

    public void setCostPurchaseServiceTaxExclude(BigDecimal costPurchaseServiceTaxExclude) {
        this.costPurchaseServiceTaxExclude = costPurchaseServiceTaxExclude;
    }

    public BigDecimal getCostPurchaseOtherTaxExclude() {
        return costPurchaseOtherTaxExclude;
    }

    public void setCostPurchaseOtherTaxExclude(BigDecimal costPurchaseOtherTaxExclude) {
        this.costPurchaseOtherTaxExclude = costPurchaseOtherTaxExclude;
    }

    public BigDecimal getCostProjectManageTaxExclude() {
        return costProjectManageTaxExclude;
    }

    public void setCostProjectManageTaxExclude(BigDecimal costProjectManageTaxExclude) {
        this.costProjectManageTaxExclude = costProjectManageTaxExclude;
    }

    public BigDecimal getCostOtherOtherTaxExclude() {
        return costOtherOtherTaxExclude;
    }

    public void setCostOtherOtherTaxExclude(BigDecimal costOtherOtherTaxExclude) {
        this.costOtherOtherTaxExclude = costOtherOtherTaxExclude;
    }


    public BigDecimal getCostExpropriationTaxExclude() {
        return costExpropriationTaxExclude;
    }

    public void setCostExpropriationTaxExclude(BigDecimal costExpropriationTaxExclude) {
        this.costExpropriationTaxExclude = costExpropriationTaxExclude;
    }

    public BigDecimal getCostCompanyManageTaxExclude() {
        return costCompanyManageTaxExclude;
    }

    public void setCostCompanyManageTaxExclude(BigDecimal costCompanyManageTaxExclude) {
        this.costCompanyManageTaxExclude = costCompanyManageTaxExclude;
    }


    /**
     * 计算所有的含税收入
     */
    public BigDecimal getIncomeTotalTaxInclude() {
        if(null == incomeDeviceTaxInclude || null == incomeEngineerTaxInclude || null == incomeServiceTaxInclude){
            return null;
        }
        return incomeDeviceTaxInclude.add(incomeEngineerTaxInclude)
                .add(incomeServiceTaxInclude);
    }

    /**
     * 计算所有的不含税收入
     */
    public BigDecimal getIncomeTotalTaxExclude() {
        if(null == incomeDeviceTaxExclude || null == incomeEngineerTaxExclude || null ==incomeServiceTaxExclude){
            return null;
        }
        return incomeDeviceTaxExclude.add(incomeEngineerTaxExclude)
                .add(incomeServiceTaxExclude);
    }

    /**
     * 计算所有的成本含税
     */
    public BigDecimal getCostTotalTaxInclude() {
        if(null == costPurchaseDeviceTaxInclude
                || null == costPurchaseBuildTaxInclude
                || null == costPurchaseServiceTaxInclude
                || null == costPurchaseOtherTaxInclude
                /*|| null == costProjectManageTaxInclude*/
                || null == costOtherOtherTaxInclude){
            return null;
        }
        return costPurchaseDeviceTaxInclude
                .add(costPurchaseBuildTaxInclude)
                .add(costPurchaseServiceTaxInclude)
                .add(costPurchaseOtherTaxInclude)
                /*.add(null == costProjectManageTaxInclude ? new BigDecimal(0) : costProjectManageTaxInclude)*/
                .add(costOtherOtherTaxInclude);
    }

    /**
     * 计算所有的成本不含税
     */
    public BigDecimal getCostTotalTaxExclude() {
        if(null == costPurchaseDeviceTaxExclude
                || null == costPurchaseBuildTaxExclude
                || null == costPurchaseServiceTaxExclude
                || null == costPurchaseOtherTaxExclude
                || null == costProjectManageTaxExclude
                || null == costOtherOtherTaxExclude){
            return null;
        }
        return costPurchaseDeviceTaxExclude.add(costPurchaseBuildTaxExclude)
                .add(costPurchaseServiceTaxExclude)
                .add(costPurchaseOtherTaxExclude)
                .add(costProjectManageTaxExclude)
                .add(costOtherOtherTaxExclude);
    }

    /**
     * 计算项目毛利
     * 收入总计（不含税）-成本总计（不含税）-财务费用总计（不含税）
     */
    public BigDecimal getProjectGrossProfit() {
        BigDecimal incomeTotalTaxExclude = getIncomeTotalTaxExclude();
        BigDecimal costTotalTaxExclude = getCostTotalTaxExclude();
        BigDecimal costExpropriationTaxExclude = getCostExpropriationTaxExclude();
        if(null == incomeTotalTaxExclude || null == costTotalTaxExclude || null == costExpropriationTaxExclude){
            return null;
        }
        return incomeTotalTaxExclude.subtract(costTotalTaxExclude).subtract(costExpropriationTaxExclude);
    }

    /**
     * 计算项目毛利率
     * 毛利（不含税）/收入总计（不含税
     */
    public BigDecimal getProjectGrossProfitRate() {
        BigDecimal projectGrossProfit = getProjectGrossProfit();
        BigDecimal incomeTotalTaxExclude = getIncomeTotalTaxExclude();
        if(null == projectGrossProfit || null == incomeTotalTaxExclude){
            return null;
        }
        return projectGrossProfit.multiply(new BigDecimal(100)).divide(incomeTotalTaxExclude,2,BigDecimal.ROUND_HALF_UP);
    }

    /**
     * 计算项目贡献利润
     * 项目毛利（不含税）-公司管理费用总计（不含税）
     */
    public BigDecimal getProjectContributionProfit() {
        BigDecimal projectGrossProfit = getProjectGrossProfit();
        BigDecimal costCompanyManageTaxExclude = getCostCompanyManageTaxExclude();
        if(null == projectGrossProfit || null == costCompanyManageTaxExclude){
            return null;
        }
        return projectGrossProfit.subtract(costCompanyManageTaxExclude);
    }
    /**
     * 计算项目贡献利润率
     * 贡献利润（不含税）/收入总计（不含税）
     */
    public BigDecimal getProjectContributionProfitRate() {
        BigDecimal projectContributionProfit = getProjectContributionProfit();
        BigDecimal incomeTotalTaxExclude = getIncomeTotalTaxExclude();
        if(null == projectContributionProfit || null == incomeTotalTaxExclude){
            return null;
        }
        return projectContributionProfit.multiply(new BigDecimal(100)).divide(incomeTotalTaxExclude, 2,BigDecimal.ROUND_HALF_UP);
    }
}
