package cn.palmte.work.service;

import cn.palmte.work.model.SysConfig;
import cn.palmte.work.model.SysConfigRepository;
import cn.palmte.work.pojo.SysConfigRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;

@Service
public class SysConfigService {

    @Autowired
    private SysConfigRepository sysConfigRepository;


    public void saveOrUpdate(SysConfigRequest sysConfigRequest) {
        SysConfig underwrittenTaxRate = sysConfigRepository.findByCodeEquals("underwrittenTaxRate");
        underwrittenTaxRate.setValue(sysConfigRequest.getUnderwrittenTaxRate());
        underwrittenTaxRate.setUpdateTime(new Date());
        sysConfigRepository.saveAndFlush(underwrittenTaxRate);

        SysConfig projectContributionProfitRateThreshold = sysConfigRepository.findByCodeEquals("projectContributionProfitRateThreshold");
        projectContributionProfitRateThreshold.setValue(sysConfigRequest.getProjectContributionProfitRateThreshold());
        projectContributionProfitRateThreshold.setUpdateTime(new Date());
        sysConfigRepository.saveAndFlush(projectContributionProfitRateThreshold);

    }
}
